# -*- coding: utf-8 -*-
#
# Copyright (c) 2021, HILSTER GmbH, Germany - https://hilster.io
# All rights reserved.
#
# This file was generated by wrappergenerator.py
#

from oser.core import PaddingFlag as _PaddingFlag


class PaddingFlag(_PaddingFlag):
    """
    `PaddingFlag` is a one bit padding.
    """

    def __init__(self, value=False, strict=False, format=None):
        """
        Args:
            value=False (bool): can be ``True`` or ``False``.
            strict=False (bool): if set to ``True`` an exception is raised when decoded data
                does not match ``value``.
            format=None (string): Use "hex" to format values to hexadecimal.
                Use "bin" to format values to binary.
        """
        super(PaddingFlag, self).__init__(value=value, strict=strict, format=format)

    def get_byte_size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(PaddingFlag, self).get_byte_size()

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bits that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bits that were decoded.
        """
        return super(PaddingFlag, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be
                encoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            bytes: the encoded binary string.
        """
        return super(PaddingFlag, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(PaddingFlag, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.

        Args:
            stop_at=None (object): stop introspection at ``stop_at``.
        """
        return super(PaddingFlag, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(PaddingFlag, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(PaddingFlag, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(PaddingFlag, self).set_fuzzing_values(values=values)

    def get_size(self):
        """
        Return the size in bits.

        Returns:
            int: the length of the bit type in bits.
        """
        return super(PaddingFlag, self).get_size()

    def up(self):
        """
        Return the parent element.
        """
        return super(PaddingFlag, self).up()

