# -*- coding: utf-8 -*-
#
# Copyright (c) 2021, HILSTER GmbH, Germany - https://hilster.io
# All rights reserved.
#
# This file was generated by wrappergenerator.py
#

from oser.core import RandomBitsFuzzingValue as _RandomBitsFuzzingValue
from oser.core import RandomBytesFuzzingValue as _RandomBytesFuzzingValue
from oser.core import RandomFloatFuzzingValue as _RandomFloatFuzzingValue
from oser.core import RandomIntegerFuzzingValue as _RandomIntegerFuzzingValue
from oser.core import RandomStringFuzzingValue as _RandomStringFuzzingValue


def RandomBitsFuzzingValue(length, count, seed=None):
    """
    A random bits fuzzing value generator.
    Random values are generated using :func:`random.getrandbits`.

    Args:
        length (int): the number of bits to be generated.
        count (int): the number of values to be generated.
        seed=None (int): the seed for :func:`random.seed`. If ``None`` is supplied no
            seed is set.

    Returns:
        callable: a callable that generates ``count`` random bits.
    """
    return _RandomBitsFuzzingValue(length=length, count=count, seed=seed)


def RandomBytesFuzzingValue(length, count, choices=None, seed=None):
    """
    A random bytes fuzzing value generator.
    Random values are generated using :func:`random.choice` with ``choices``.

    Args:
        length (int): the number of bytes to be generated..
        count (int): the number of values to be generated.
        choices=None (list of int): if set to ``None`` ``list(range(256))`` is used.
        seed=None (int): the seed for :func:`random.seed`. If ``None`` is supplied no
            seed is set.

    Returns:
        callable: a callable that generates ``count`` random bytes values.
    """
    return _RandomBytesFuzzingValue(length=length, count=count, choices=choices, seed=seed)


def RandomFloatFuzzingValue(factor, count, seed=None):
    """
    A random float fuzzing value generator.
    Random values are generated using :func:`random.random`.

    Args:
        factor (float): the factor the random value is multiplied by.
        count (int): the number of values to be generated.
        seed=None (int): the seed for :func:`random.seed`. If ``None`` is supplied no
            seed is set.

    Returns:
        callable: a callable that generates ``count`` random float values
            between ``a`` and ``b``.
    """
    return _RandomFloatFuzzingValue(factor=factor, count=count, seed=seed)


def RandomIntegerFuzzingValue(a, b, count, seed=None):
    """
    A random integer fuzzing value generator.

    Args:
        a (int): the lower limit for :func:`random.randint`.
        b (int): the upper limit for :func:`random.randint`.
        count (int): the number of values to be generated.
        seed=None (int): the seed for :func:`random.seed`. If ``None`` is supplied no
            seed is set.

    Returns:
        callable: a callable that generates ``count`` random integer 
            values between ``a`` and ``b``.
    """
    return _RandomIntegerFuzzingValue(a=a, b=b, count=count, seed=seed)


def RandomStringFuzzingValue(length, count, chars=None, seed=None):
    """
    A random string fuzzing value generator.
    Random values are generated using :func:`random.choice` with ``chars``.

    Args:
        length (int): the number of characters to be generated..
        count (int): the number of values to be generated.
        chars=None (string): if set to ``None`` ``string.printable`` is used
            (digits, letters, punctuation and whispaces).
        seed=None (int): the seed for :func:`random.seed`. If ``None`` is supplied no
            seed is set.

    Returns:
        callable: a callable that generates ``count`` random string values.
    """
    return _RandomStringFuzzingValue(length=length, count=count, chars=chars, seed=seed)


